#-*- encoding: utf-8 -*-
import os, stat
import locale
import sys
import json
from enum import Enum
from operator import *

#windows格式文件系统类型，'HPFS/NTFS/exFAT'类型/gpt 格式类型
WinDiskTypes = ['HPFS/NTFS/exFAT', 'Microsoft']
LinuxDiskTypes = ['Linux']
#windows系统注册表所在目录，当前暂不考虑windows装载在别的目录的情况
WindowsRegistryPath = 'Windows/System32/config'
WindowsRegistryPathXP = 'WINDOWS/system32/config'

#windows盘符对应驱动器枚举情况，因为手边没有合适设备测试，暂时没有考虑软驱、以及zip disk的情况，后面碰到对应实际场景时再加上
class WinDriverKindsEnum(Enum):
    KIND_FIXED_DISK = 0
    KIND_DMIO = 1
    KIND_USBSTORE_CDROM = 2
    KIND_IDE_CDROM = 3
    KIND_SCSI_CDROM = 4
    KIND_USBSTORE_DISK = 5
    KIND_OTHER = 6

LANGUAGE=locale.getdefaultlocale()[0]
def _(s):
    interpretor = {'Device':u'设备', 'Disk identifier':u'磁盘标识符', ':':u'：', 'Disk Label':'磁盘标签类型'}
    if eq (LANGUAGE, 'en_US'):
        return s
    else:
        return interpretor[s]

#函数返回windows设备信息列表，以及物理磁盘信息列表
#对fdisk -l返回的信息进行分析，返回各个windows分区的driver和起点
#函数中我们以'设备'和'磁盘标识符'作为定位字符串
#英文环境通过自定义的 _() 函数支持
def listWindowsDevicesAndPhysicalDisks():
    res = os.popen('sudo fdisk -l').read()
    #flist -l信息分成多段，段间以空行分割
    paras = res.split('\n\n\n')
    #if gt(len(paraDevices), 1):
    #    otherDevices = paraDevices[1]
    #else:
    #    otherDevices = None
    #if otherDevices is not None:
    #    otherLineDevices = otherDevices.split('\n')[1:]
    #    otherDevices = [line.split() for line in otherLineDevices]
    #FIXME 多块硬盘时，第二块盘上的 deviceLinus 自动挂载?
    #下面len(words)==8代表设备是个启动设备(‘启动'列为*，非启动设备'启动'列为空格或\t

    deviceWins={}
    deviceLinus={}
    diskPhysicals={}

    for para in paras:
        #找到含有磁盘标识符的那一段，找到倒数第二行，也就是标签为 dos/gpt
        #有一个包含磁盘信息的信息，这个段以'设备\t启动\t起点\t末尾\t扇区\t大小\tId\t类型'行开头，下面的数据是个表形式
        lparas = para.split('\n\n')
        print (para)
        paraType = [identifier.split(_(':')) for identifier in  para.split('\n') if identifier.startswith(_('Disk Label'))]
        if len(paraType) == 0:
            continue

        #for section in lparas:
        #    if section.startswith(_('Device')):
        #        print (section)
        lineDevices = [section.split('\n') for section in lparas if section.startswith(_('Device'))]
        deleteHead = lineDevices[0][1:]
        devices=[]
        for line in deleteHead:
            devices.append (line.split())

        #对于每块设备找到对应的 windows 设备和 linus 设备
        if eq(paraType[0][-1], "dos"):
            device = para.split(_(':'))[0].split()[1]
            deviceWins.update({words[0] : (int(words[2]) if len(words)==8 else int(words[1])) for words in devices if len(words)!=0 and words[-1] in WinDiskTypes})
            deviceLinus.update({words[0] : (int(words[2]) if len(words)==8 else int(words[1])) for words in devices if len(words)!=0 and words[-1] in LinuxDiskTypes})
            diskPhysicals.update({device : int(item.split(_(':'))[-1].strip()[2:],16) for item in para.split('\n') if item.startswith(_('Disk identifier'))})
        elif eq(paraType[0][-1], "gpt"):
            if eq(LANGUAGE, "en_US"):
                index = 5
            else:
                index = -2
        # 第一块 gpt 分区的设备
            deviceWins.update({words[0] : (int(words[2]) if len(words)==8 else int(words[1])) for words in devices if len(words)!=0 and words[index] in WinDiskTypes})
            deviceLinus.update({words[0] : (int(words[2]) if len(words)==8 else int(words[1])) for words in devices if len(words)!=0 and words[index] in LinuxDiskTypes})
            #guid = [para.split('\n')[-1].split(_(':'))[-1] for para in paras if para.split('\n')[-1].startswith(_('Disk identifier'))][0].split(_(':'))[-1]
            diskPhysicals.update({"device":"guid"})
        else:
            print("error")

    print ("----------------------------------------------------")
    print (deviceWins)
    print (deviceLinus)
    return deviceWins, deviceLinus, diskPhysicals

#执行mount，列出所有设备mount信息,我们关心的是设备以及所mount的目录两个内容
#mount 有问题，如果 windows 重命名有空格，比如 This is C
#不太方便找路径，改为 json 解析，方便
def listDeviceMounts(device):
    resJson = os.popen('findmnt -J --source %s' % device).read()
    if len(resJson) == 0:
        return None

    value = json.loads(resJson)
    return value['filesystems'][0]['target']

#获得设备挂载缺省目录
def getPathMount(device):
    path = '/media/nfs_dev_%s' % device.split('/')[-1]
    #print ('getPathMount: %s - %s' % (device, path))
    return path

#挂载设备
def doDeviceMount(device):
    res = os.popen('blkid %s -s TYPE' % device).read()
    
    if len(res) == 0 or "swap" in res or "vfat" in res:
        return None

    pathMount = getPathMount(device)
    if not os.path.exists(pathMount):
        res = os.system('mkdir %s' % pathMount)
        if res!=0:
            print('Cannot mkdir path %s' % pathMount)
            return None
    res = os.system('mount %s %s' % (device, pathMount))
    if res!=0:
        print ('Cannot mount %s %s with result=%d' % (device, pathMount, res))
        return None
    os.chmod(pathMount, stat.S_IRWXO | stat.S_IRWXG | stat.S_IRWXU)
    return pathMount


def doMatch():
    deviceWins, deviceLinus, diskPhysicals = listWindowsDevicesAndPhysicalDisks()
    #对于每个windows设备，如果已经被挂载，则记录其挂载目录，如果未被挂载，则执行doDeviceMount对其进行挂载在某个指定目录，并记录该指定目录
    for device in deviceLinus:
        if listDeviceMounts (device) is None:
            doDeviceMount (device)

    deviceMountsOfWin = {}
    for device in deviceWins:
        value = listDeviceMounts(device)
        if value is not None:
            deviceMountsOfWin[device] = value
        else:
            pathMount = doDeviceMount(device)
            if pathMount is not None:
                deviceMountsOfWin[device] = pathMount
            else:
                deviceMountsOfWin[device] = "safe"
    
if __name__ == '__main__':
    doMatch()
